//+-------------------------------------------------------------------------------+ 
//|                                                            DoubleMacd+Rsi.mq4 |
//|                                                     http://www.forex-tsd.com  |
//|                                                                               |
//| You are NOT ALLOWED to distribute this EA in any public forum                 |
//| Property of  http://www.forex-tsd.com ELITE section ONLY                      |
//+-------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#include <stdlib.mqh>

//
//
//
//
//

extern int    MagicNumber         = 190722;
extern bool   EcnBroker           = false;
extern bool   NoHedge             = false;
extern bool   UseAutomaticMM      = false;
extern double Risk                = 1.50;
extern double BaseLot             = 0.1;
extern bool   CloseOnTrendChange  = false;

//
//
//
//
//

extern string  _                     = "Range settings";
extern double  Range.stopLoss        = 1.0;
extern double  Range.takeProfit      = 1.0;
extern double  Range.trailingStop    = 0.0;
extern double  Range.lockProfit      = 0.0;
extern int     Range.timeFrame       = PERIOD_H4;
extern int     Range.length          = 20;

extern string  __                    = "Indicators settings";
extern int     FastMacd.FastEMA      =  5;
extern int     FastMacd.SlowEMA      = 15;
extern int     SlowMacd.FastEMA      = 10;
extern int     SlowMacd.SlowEMA      = 20;
extern int     Rsi.Period            = 21;
extern int     Rsi.UpLevel           = 50;
extern int     Rsi.DnLevel           = 50;

extern string  ___                   = "";
extern int     AllowedSlippage       =  0;
extern bool    showMessages          = false;

//
//
//
//
//

int    NumberOfTries = 5;
double pipMultiplier = 1;
double currentRange  = 0;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()   { return(0); }
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define __trendUp       1
#define __trendDown    -1
#define __trendNeutral  0

//
//
//
//
//

int start()
{     
   if (!CheckTerminalStatus()) return(0);
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;               

   //
   //
   //
   //
   //
 
      currentRange = getRange(Range.timeFrame,Range.length);
      if (currentRange==0)
            { showTwoStateMessage("noDataForRange","not enough data for range",false); return(0); }
      else    showTwoStateMessage("noDataForRange","range OK"                 ,true);
   

   //
   //
   //
   //
   //
   
         int trendDirection = findTrend();  manageOpenedOrders(trendDirection);
      
   //
   //
   //
   //
   //

   int openedBuys=0;
   int openedSells=0;
   if (countOpenedOrders(openedBuys,openedSells)==0)
   {
      double tradeLots = getLots(currentRange);
         if(AccountFreeMargin()<tradeLots*MarketInfo(Symbol(),MODE_MARGINREQUIRED))
            { showTwoStateMessage("money","Not enough money to trade "+DoubleToStr(tradeLots,2),false); return(0); }
         else showTwoStateMessage("money","Continuing to trade",true);
      
      //
      //
      //
      //
      //
      
      if (trendDirection==__trendUp   && openedSells==0) Buy(tradeLots);
      if (trendDirection==__trendDown && openedBuys ==0) Sell(tradeLots);
   }  
   return(0);      
}



//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//    lots and range calculation
//
//
//

double getLots(double range)
{
   RefreshRates();
   double step   = MarketInfo(Symbol(),MODE_LOTSTEP);
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
         lots = AccountFreeMargin()*(Risk/100.0)/(range*Range.stopLoss*MarketInfo(Symbol(),MODE_TICKVALUE)/Point);
      }
   }      
   return(MathMax(MathMin(lots,maxLot),minLot));   
}

//
//
//
//
//

double getRange(int timeFrame,int length)
{
   static double   newRange = 0;
   static datetime newTime  = 0;
   static int      newBars  = 0;
   string symbol = Symbol();
   
 
   //
   //
   //
   //
   //
     
   if (newTime != iTime(symbol,timeFrame,0) || newBars != iBars(symbol,timeFrame))
   {
      newTime  = iTime(symbol,timeFrame,0);
      newBars  = iBars(symbol,timeFrame);
      newRange = 0;
   
      //
      //
      //
      //
      //
      
      int d = 0;
      for (int i=0;d<length;i++)
      {
         double high = iHigh(symbol,timeFrame,i+1);
         double low  = iLow (symbol,timeFrame,i+1);
         
         if (high==0 || low==0) break;
         if (TimeDayOfWeek(iTime(symbol,timeFrame,i+1))==0) continue;
      
         //
         //
         //
         //
         //
            
         newRange += (high-low); d++;
      }
      newRange /= (d+1.0);
   }      
   return(newRange);
}


//----------------------------------------------------------------------------------------
//       trend determination       
//----------------------------------------------------------------------------------------
//
//
//
//
//



int findTrend()
{
   RefreshRates();
   double FastMacd2 = iMACD(NULL,0,FastMacd.FastEMA,FastMacd.SlowEMA,1,PRICE_CLOSE,MODE_MAIN,2);
   double FastMacd1 = iMACD(NULL,0,FastMacd.FastEMA,FastMacd.SlowEMA,1,PRICE_CLOSE,MODE_MAIN,1);
   double SlowMacd  = iMACD(NULL,0,SlowMacd.FastEMA,SlowMacd.SlowEMA,1,PRICE_CLOSE,MODE_MAIN,1);
   double Rsi       = iRSI(NULL,0,Rsi.Period,PRICE_CLOSE,1);
   
   //
   //
   //
   //
   //

   if(SlowMacd>0 && Rsi>Rsi.UpLevel && FastMacd2<0 && FastMacd1>0) return(__trendUp);
   if(SlowMacd<0 && Rsi<Rsi.DnLevel && FastMacd2>0 && FastMacd1<0) return(__trendDown);
                                                                   return(__trendNeutral);
}



//----------------------------------------------------------------------------------------
//       opened orders management 
//----------------------------------------------------------------------------------------
//
//
//
//
//

int countOpenedOrders(int& openedBuys,int& openedSells)
{
   int openedOrders=0;   
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderSymbol() != Symbol()) continue;
      if(NoHedge)
      {
         if(OrderType() == OP_BUY)  openedBuys++;
         if(OrderType() == OP_SELL) openedSells++;
      }
      if(OrderMagicNumber() != MagicNumber) continue;
                  
      //
      //
      //
      //
      //
                  
      if(OrderType() == OP_BUY || OrderType() == OP_SELL) openedOrders++;
   }      
   return(openedOrders);
}

//
//
//
//
//

void manageOpenedOrders(int currentDirection)
{
   int    err,i,c;
   double trailingStop = currentRange*Range.trailingStop;
   double lockProfit   = currentRange*Range.lockProfit;
   double newStop;
   double curStop;
   double minStop;
   
   //
   //
   //
   //
   //
   
   for(i=OrdersTotal()-1; i >= 0 ; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol()      != Symbol())    continue;

      //
      //
      //
      //
      //
      
      if(OrderType() == OP_BUY)
      {
         if (CloseOnTrendChange) { if (currentDirection==__trendDown) CloseOrder(0,OrderTicket()); continue; }
         
         //
         //
         //
         //
         //
         
         if (Range.trailingStop>0)
         {
            for(c=0; c<NumberOfTries; c++)
            { 
               RefreshRates();
                  curStop = NormalizeDouble(OrderStopLoss(),Digits);
                  newStop = NormalizeDouble(Bid-trailingStop,Digits);
                  minStop = NormalizeDouble(OrderOpenPrice()+lockProfit,Digits);
                  if (newStop>curStop && newStop>minStop)
                     {
                        OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                        err = GetLastError(); checkError("stop loss modified",err);
                     }                        
                  if(err==4 || err==136 || err==137 || err==138 || err==146) continue;
                  break;
            }                     
         }
      }
      
      //
      //
      //
      //
      //
      
      if(OrderType() == OP_SELL)
      {
         if (CloseOnTrendChange) { if (currentDirection==__trendUp) CloseOrder(0,OrderTicket()); continue; }

         //
         //
         //
         //
         //
         
         if (Range.trailingStop>0)
         {
            for(c=0; c<NumberOfTries; c++)
            { 
               RefreshRates();
                  curStop = NormalizeDouble(OrderStopLoss(),Digits);
                  newStop = NormalizeDouble(Ask+trailingStop,Digits);
                  minStop = NormalizeDouble(OrderOpenPrice()-lockProfit,Digits);
                  if (curStop>0 && newStop<curStop && newStop<minStop)
                     {
                        OrderModify(OrderTicket(),OrderOpenPrice(),newStop,OrderTakeProfit(),0);
                        err = GetLastError(); checkError("stop loss modified",err);
                     }                        
                  if(err==4 || err==136 || err==137 || err==138 || err==146) continue;
                  break;
            }                     
         }
      }
   }
}




      

//----------------------------------------------------------------------------------------
//       orders management
//----------------------------------------------------------------------------------------
//       buy and sell orders
//----------------------------------------------------------------------------------------
//
//
//
//
//

void setStopLoss(int ticket,double stopLoss)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),stopLoss,OrderTakeProfit(),0);
         int err = GetLastError(); checkError("stop loss aplied",err);
         if (err==4 || err==136 || err==137 || err==138 || err==146) continue;
      break;
   }
}
void setTakeProfit(int ticket,double takeProfit)
{
   if (ticket != -1)
   for(int c=0; c<NumberOfTries; c++)
   {
      OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),takeProfit,0);
         int err = GetLastError(); checkError("stop loss aplied",err);
         if (err==4 || err==136 || err==137 || err==138 || err==146) continue;
      break;
   }
}

//
//
//
//
//

void Buy(double Lots)
{ 
   double StopLoss   = currentRange*Range.stopLoss;
   double TakeProfit = currentRange*Range.takeProfit;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0; c<NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss>0)   sl = Bid-StopLoss;
            if (TakeProfit>0) tp = Ask+TakeProfit;
         }            
      
         int ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,AllowedSlippage*pipMultiplier,sl,tp,"PCBreakout - buy",MagicNumber,0,Blue);
         int err    = GetLastError(); checkError("buy order opened",err);
            if (err==4 || err==136 || err==137 || err==138 || err==146 || ticket<0) continue;
         
            //
            //
            //
            //
            //
            
         if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Bid-StopLoss);
         if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Ask+TakeProfit);
         break;
   } 	    
}

//
//
//
//
//

void Sell(double Lots)
{        
   double StopLoss   = currentRange*Range.stopLoss;
   double TakeProfit = currentRange*Range.takeProfit;
   
   //
   //
   //
   //
   //
   
   if (IsTesting() || CheckTradeAllowed())
   for(int c=0;c <NumberOfTries; c++)
   { 
      RefreshRates();
      double sl=0;
      double tp=0;
         if (!EcnBroker)
         {
            if (StopLoss>0)   sl = Ask+StopLoss;
            if (TakeProfit>0) tp = Bid-TakeProfit;
         }
      
         int ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,AllowedSlippage*pipMultiplier,sl,tp,"PCBreakout - sell",MagicNumber,0,Red);
         int err = GetLastError(); checkError("sell order opened",err);
            if (err==4 || err==136 || err==137 || err==138 || err==146 || ticket<0) continue;

            //
            //
            //
            //
            //

         if (EcnBroker && StopLoss>0)   setStopLoss(ticket,Ask+StopLoss);
         if (EcnBroker && TakeProfit>0) setTakeProfit(ticket,Bid-TakeProfit);
         break;
   }
}




//----------------------------------------------------------------------------------------
//       orders closing and closing all (panic close)
//----------------------------------------------------------------------------------------
//
//
//
//
//

void CloseOrder(double lotsToClose=0,int ticket=-1)
{
   string message;
   int    err    = 0;
   double minLot = NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),2);

   //
   //
   //
   //
   //
      
   if (IsTesting() || CheckTradeAllowed())
   { 
      for(int i=OrdersTotal()-1; i>=0; i--)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if (OrderMagicNumber()!=MagicNumber) continue;
         if (OrderSymbol() != Symbol())       continue;
         if (ticket!=-1)
            if (OrderTicket()!=ticket) continue;
         
         //
         //
         //
         //
         //
         
         if (OrderType()==OP_BUY || OrderType()==OP_SELL)
         {
            RefreshRates();
            if (OrderType()==OP_BUY)
                  { string operation = "buy"; color  theColor  = Blue; double cp = Bid;}  
            else  {        operation = "sell";       theColor  = Red;         cp = Ask;}
            
            //
            //
            //
            //
            //

            if (lotsToClose==0) lotsToClose = OrderLots();
            if (lotsToClose!=OrderLots())
            {
               lotsToClose = MathMax(minLot,lotsToClose);
                  if (OrderLots() < 2.0*minLot)
                     lotsToClose = OrderLots();
            }               
            
            if (lotsToClose!=OrderLots())
                     message="partialy closed "+operation+" - closed "+DoubleToStr(lotsToClose,2)+" lots";
            else     message=operation+" order closed";
            
            //
            //
            //
            //
            //
            
            for(int c=0 ; c<NumberOfTries; c++)
            {
               OrderClose(OrderTicket(),lotsToClose,cp,AllowedSlippage*pipMultiplier,theColor);
                  err=GetLastError();
                     checkError(message,err);
                     if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        RefreshRates();
                           if (OrderType()==OP_BUY)
                                 cp = Bid;  
                           else  cp = Ask;
                           continue;
                     }
                  break; 
            }
            break;
         }            
      }         
   }  
}


//----------------------------------------------------------------------------------------
//       terminal status handling
//----------------------------------------------------------------------------------------
//
//
//
//
//

bool CheckTradeAllowed() { return(IsTradeAllowed() && !IsStopped() && IsExpertEnabled() && !IsTradeContextBusy()); }
bool CheckTerminalStatus()
{
   bool status=false;
   
   //
   //
   //
   //
   //
   
   while(true)
   {
         if (!IsConnected())
             { showTwoStateMessage("connected","No connection to server",False); break; }
         else  showTwoStateMessage("connected","Reconected to server",true);
         if ( IsStopped())
             { showTwoStateMessage("stopped","EA stopped",False); break; }  
         else  showTwoStateMessage("stopped","EA started again",true);
         if (!IsTradeAllowed())
             { showTwoStateMessage("allowed","Trading not allowed",false); break; }
         else  showTwoStateMessage("allowed","Trading allowed again",true);
         if (!IsExpertEnabled() && !IsTesting())
            { showTwoStateMessage("disabled","EA''s are disabled",false); break; }
         else showTwoStateMessage("disabled","EA''s are enabled again",true);
         if ( IsTradeContextBusy())
            { showTwoStateMessage("busy","Trade contest busy",false); break; }
         else showTwoStateMessage("busy","Trade contest ready again",true);

      //
      //
      //
      //
      //
      
      status=true;
      break;
   }
   return(status);
}


//----------------------------------------------------------------------------------------
//       messages handling
//----------------------------------------------------------------------------------------
//
//
//
//
//
//

bool   msg.errState[];
string msg.errNames[];
string msg.messageText[10];
color  msg.messageColor[10];
int    msg.lastMessage=0;

//
//
//
//
//

void checkError(string what,int err)
{
   showMessage(what);
   if(err!=0)
         showMessage("error occured :"+ErrorDescription(err),Red);

}

//
//
//
//
//

void showTwoStateMessage(string name, string message, bool state)
{
   for(int i=ArraySize(msg.errNames)-1; i>=0; i--) if (msg.errNames[i]==name) break;
   if (i==-1)
      {
         int size = ArraySize(msg.errNames)+1;
         i = size-1;
            ArrayResize(msg.errNames,size); msg.errNames[i] = name;
            ArrayResize(msg.errState,size); msg.errState[i] = true;
      }

   //
   //
   //
   //
   //

   if (msg.errState[i]!= state)
   {   
      msg.errState[i] = state;
      if (state==false)
            showMessage(message,Red);
      else  showMessage(message,Green);
   }      
}

//
//
//
//
//

void showMessage(string text, color theColor=Gray)
{
   if(!showMessages) { Print(text); return; }
   
   //
   //
   //
   //
   //
   
   if(msg.lastMessage>9)
   {
      for(int i=0; i<9; i++)
      {
         msg.messageText[i] =msg.messageText[i+1];
         msg.messageColor[i]=msg.messageColor[i+1];
      }
      msg.lastMessage = 9;
   }

   //
   //
   //    set message que text and color
   //
   //
   
      msg.messageText[msg.lastMessage]  = text+" - "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
      msg.messageColor[msg.lastMessage] = theColor;
   
   //
   //
   //
   //
   //
      
   for(i=0; i<=msg.lastMessage; i++)
   {
      string name = "msg.que"+i;
      if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_LABEL,0,0,0);
            ObjectSet(name,OBJPROP_CORNER,3);
            ObjectSet(name,OBJPROP_XDISTANCE,5);
            ObjectSet(name,OBJPROP_YDISTANCE,5+14*i);
      }
      ObjectSetText(name,msg.messageText[i],9,"Arial",msg.messageColor[i]);
   }
   msg.lastMessage++;
   WindowRedraw();
}